//==========================================================================
// Mouse Injector for GoldenEye 007/Perfect Dark
//==========================================================================
// Copyright (c) 2017, stolen + carnivorous's fixes
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//     * Redistributions of source code must retain the above copyright
//       notice, this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright
//       notice, this list of conditions and the following disclaimer in the
//       documentation and/or other materials provided with the distribution.
//     * Neither the name of the <organization> nor the
//       names of its contributors may be used to endorse or promote products
//       derived from this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL STOLEN BE LIABLE FOR ANY
// DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//==========================================================================
// How to compile
//==========================================================================
// windres -i icon.rc -F pe-i386 --input-format=rc -o icon.res -O coff
// gcc -ansi -O3 -m32 -std=c99 -static-libgcc -s ./manymouse/manymouse.c ./manymouse/windows_wminput.c main.c icon.res -o "Mouse Injector.exe"
// #define DEBUGMODE // uncomment for debug mode
// #define PLAYER2MODE // uncomment for P2 detection for GE/PD
//==========================================================================
// TODO: find a consistent method of detecting camspy and slayer addresses
//==========================================================================
#include <stdio.h>
#include <windows.h>
#include <tlhelp32.h>
#include "manymouse/manymouse.h"
#include "main.h"

int main(void)
{
	SetConsoleTitle("Mouse Injector");
	MOUSE.connected = ManyMouse_Init();
	int emudetect = EmulatorDetected();
	if(emudetect && MOUSE.connected > 0) // if emulator is detected & more than 1 mouse is active
	{
		int limitpolling = 0; // used for limiting emu check, pd hack & debug interface
		LoadSettings(); // load user settings from mouseinjector.ini
		Interface(); // render interface for the first time
		atexit(SaveSettings); // save when program exits
		while(emudetect) // loop only if the emulator is detected
		{
			Input();
			DetectMap();
			if(CFG.mousetoggle && currentgame != PLAYINGUNKNOWN)
				Inject();
			limitpolling++;
			if(limitpolling % 3 == 0)
			{
				if(currentgame == PLAYINGPERFECTDARK && EMU.overclock) // only exec if emu is overclocked, else will cause stuttering
					PDSpeedHack();
				if(CFG.debug)
					Interface();
			}
			if(limitpolling == 200)
			{
				limitpolling = 0;
				emudetect = EmulatorDetected();
			}
			Sleep(tickrate);
		}
	}
	else // if emulator/mouse is not detected
	{
		printf(!emudetect ? "\n %s%s\n\n   Emulator not detected. Closing..." : "\n %s%s\n\n   Mouse not detected. Closing..." , TITLE, LINE);
		Sleep(2000); // wait 2 seconds before closing program
	}
	ManyMouse_Quit(); // close mouse driver
	CloseHandle(EMU.handle); // close the handle
	return 0;
}
//==========================================================================
// Purpose: checks user input and changes program settings based upon user input
// Changes Globals: CFG.mousetoggle, MOUSE.lock, CFG.selectedoption, CFG.invertpitch, CFG.crouchtoggle, CFG.geaimmode, CFG.pdradialnav, CFG.showsettings, CFG.debug, CFG.sensitivity, CFG.crosshair
//==========================================================================
void Input(void)
{
	int updateinterface = 0, updatequick = 0;
	if(K_4) // mouse toggle (4)
		CFG.mousetoggle = !CFG.mousetoggle, GetCursorPos(&MOUSE.lock), MouseMovement(), updateinterface = 1;
	if(K_5 && CFG.showsettings && !updateinterface && CFG.selectedoption != EDITINGSENSITIVITY) // mouse sensitivity (5)
		CFG.selectedoption = EDITINGSENSITIVITY, updateinterface = 1;
	if(K_6 && CFG.showsettings && !updateinterface && CFG.selectedoption != EDITINGCROSSHAIR) // crosshair sensitivity (6)
		CFG.selectedoption = EDITINGCROSSHAIR, updateinterface = 1;
	if(K_7 && CFG.showsettings && !updateinterface) // invert pitch toggle (7)
		CFG.invertpitch = !CFG.invertpitch, updateinterface = 1;
	if(K_8 && CFG.showsettings && !updateinterface) // crouch toggle (8)
		CFG.crouchtoggle = !CFG.crouchtoggle, ResetCrouchToggle(), updateinterface = 1;
	if(K_9 && CFG.showsettings && !updateinterface) // goldeneye aim mode toggle (overclock emus only) / perfect dark radial mouse control toggle (9)
	{
		if(currentgame == PLAYINGGOLDENEYE && EMU.overclock)
			CFG.geaimmode = !CFG.geaimmode, updateinterface = 1;
		else if(currentgame == PLAYINGPERFECTDARK)
			CFG.pdradialnav = !CFG.pdradialnav, updateinterface = 1;
	}
	if((K_CTRL && K_0 || K_0 && K_CTRL) && !CFG.debug && !updateinterface) // hide/show settings (CTRL+0)
		CFG.showsettings = !CFG.showsettings, updateinterface = 1;
#ifdef DEBUGMODE
	if(K_0 && CFG.showsettings && !updateinterface) // debug toggle (0)
		CFG.debug = !CFG.debug, updateinterface = 1;
#endif
	if(K_PLUS && CFG.showsettings && !updateinterface) // numpad plus (+)
	{
		if(CFG.selectedoption == EDITINGSENSITIVITY && CFG.sensitivity > 0 && CFG.sensitivity < 80)
			CFG.sensitivity++, updateinterface = 1;
		if(CFG.selectedoption == EDITINGCROSSHAIR && CFG.crosshair >= 0 && CFG.crosshair < 18)
			CFG.crosshair++, updateinterface = 1;
		updatequick = 1;
	}
	if(K_MINUS && CFG.showsettings && !updateinterface) // numpad minus (-)
	{
		if(CFG.selectedoption == EDITINGSENSITIVITY && CFG.sensitivity > 1 && CFG.sensitivity < 81)
			CFG.sensitivity--, updateinterface = 1;
		if(CFG.selectedoption == EDITINGCROSSHAIR && CFG.crosshair >= 1 && CFG.crosshair < 19)
			CFG.crosshair--, updateinterface = 1;
		updatequick = 1;
	}
	if((K_CTRL && K_F8 || K_F8 && K_CTRL) && CFG.showsettings && !updateinterface) // rebind crouch key (CTRL+F8)
		RebindCrouch(), updateinterface = 1;
	if((K_CTRL && K_F9 || K_F9 && K_CTRL) && currentgame != PLAYINGUNKNOWN) // hard mode preset for GE & PD (CTRL+F9)
	{
		if(currentgame == PLAYINGGOLDENEYE) // GE
		{
			WriteMemoryFloat(0x0002A9A4, 0.75, 0); // 75% [health]
			WriteMemoryFloat(0x0002A9A8, 3, 0); // 300% [damage]
			WriteMemoryFloat(0x0002A9AC, 6, 0); // 60% [accuracy]
			WriteMemoryFloat(0x0002A9A0, 1, 0); // 100% [reaction] (anything over 100% crashes some maps)
			WriteMemoryFloat(0x00040A90, 0, 0); // off [auto-aim]
			WriteMemoryFloat(0x00040AA8, 0, 0); // off [sight on-screen]
			WriteMemoryFloat(0x00040AC0, 0, 0); // off [ammo on-screen]
		}
		else // PD
		{
			WriteMemoryFloat(0x0009DFF4, 0.80, 0); // 80% [health]
			WriteMemoryFloat(0x0009DFF8, 1.65, 0); // 165% [damage]
			WriteMemoryFloat(0x0009DFFC, 3.5, 0); // 350% [accuracy]
			WriteMemoryInt(0x0009DFEC, 0x00708DAD, 0); // UI slider positions for health, damage and accuracy
		}
		Sleep(200); // don't repeat this too quickly, halt the program for 200 ms
	}
	if(updateinterface)
	{
		Interface();
		Sleep(100);
		if(!updatequick)
			Sleep(100);
	}
}
//==========================================================================
// Purpose: rebinds the crouch button
// Changes Globals: CFG.crouchkey
//==========================================================================
void RebindCrouch(void)
{
	int firstkey = 0, secondkey = 0;
	ClearScreen();
	printf("\n Rebinding Crouch Key\n%s\n\n   Please press the new crouch key: ", LINE);
	Sleep(1250);
	for(int i = 0; i < 0xFF; i++) // flush all keys
		GetAsyncKeyState(i);
	while(!firstkey) // search for first key press
	{
		for(int i = 0; i < 0xFF; i++)
			if(GetAsyncKeyState(i))
				firstkey = i;
		Sleep(20); // don't repeat this loop too quickly
	}
	printf("\a%d\n\n   Please press the key again: ", firstkey);
	Sleep(1000);
	for(int i = 0; i < 0xFF; i++) // flush all keys
		GetAsyncKeyState(i);
	while(!secondkey) // search for second key press
	{
		for(int i = 0; i < 0xFF; i++)
			if(GetAsyncKeyState(i))
				secondkey = i;
		Sleep(20); // don't repeat this loop too quickly
	}
	if(firstkey == secondkey) // compare keys and apply if both are the same
	{
		printf("\a%d\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n   New crouch key successfully entered, returning to menu...\n%s\n", secondkey, LINE);
		CFG.crouchkey = firstkey;
	}
	else
		printf("\a\a%d\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n   Failed! Crouch key incorrectly entered, returning to menu...\n%s\n", secondkey, LINE);
	Sleep(1750);
}
//==========================================================================
// Purpose: handles all of the screen information
//==========================================================================
void Interface(void)
{
	ClearScreen();
	if(CFG.debug)
		DebugInterface();
	else
	{
		printf("\n %s%s\n\n   Main Menu - Press [#] to Use Menu\n\n\n", TITLE, LINE); // title
		printf(CFG.mousetoggle ? "   [4] - [ON] Mouse Injection" : "   [4] - [OFF] Mouse Injection");
		if(CFG.showsettings)
		{
			printf("\n\n   [5] - Mouse Sensitivity: %d%%", CFG.sensitivity * 5);
			printf(CFG.selectedoption == EDITINGSENSITIVITY ? " [+/-]\n\n" : "\n\n");
			printf("   [6] - Crosshair Movement: ");
			printf(CFG.crosshair ? "%d%%" : "Disabled", CFG.crosshair * 100 / 6);
			printf(CFG.selectedoption == EDITINGCROSSHAIR ? " [+/-]\n\n" : "\n\n");
			printf(CFG.invertpitch ? "   [7] - [ON] Invert Pitch\n\n" : "   [7] - [OFF] Invert Pitch\n\n");
			printf(CFG.crouchtoggle ? "   [8] - [ON] Toggle Crouch\n\n" : "   [8] - [OFF] Toggle Crouch\n\n");
			printf(currentgame == PLAYINGGOLDENEYE && EMU.overclock ? (CFG.geaimmode ? "   [9] - [ON] Cursor Aiming (GE Only)\n\n" : "   [9] - [OFF] Cursor Aiming (GE Only)\n\n") : ""); // perfect dark and non-overclocked emus do not support aim mode (see Inject() faq)
			printf(currentgame == PLAYINGPERFECTDARK ? (CFG.pdradialnav ? "   [9] - [ON] Radial Menu Mouse Control\n\n" : "   [9] - [OFF] Radial Menu Mouse Control\n\n") : "");
			printf(currentgame == PLAYINGGOLDENEYE && !EMU.overclock || currentgame == PLAYINGUNKNOWN ? "\n\n" : ""); // fill up gap in interface
#ifdef DEBUGMODE
			printf("   [0] - Debug Mode\n\n");
#endif
		}
		else
			printf("\n\n\n\n\n\n\n\n\n\n\n\n");
		printf(CFG.showsettings ? "\n   [CTRL+0] - Hide Settings" : "\n   [CTRL+0] - Show Settings");
		printf("\n\n Note: [+/-] to Change Values%s\n%s\n", CFG.showsettings ? " - CTRL+F8 to Change Crouch Key" : "", LINE);
	}
}
//==========================================================================
// Purpose: loads settings stored in mouseinjector.ini
// Changes Globals: CFG.sensitivity, CFG.crosshair, CFG.invertpitch, CFG.crouchtoggle, CFG.geaimmode, CFG.pdradialnav, CFG.debug, CFG.showsettings, CFG.selectedoption, CFG.crouchkey
//==========================================================================
void LoadSettings(void)
{
	FILE *fileptr; // create a file pointer and open mouseinjector.ini from same dir as our program
	if((fileptr = fopen("mouseinjector.ini", "r")) != NULL) // if the INI exists
	{
		char line[128][128]; // char array used for file to write to
		char lines[128]; // maximum lines read size
		int counter = 0; // used to assign each line to a array
		while(fgets(lines, sizeof(lines), fileptr) != NULL && counter < 11) // read the first 10 lines
		{
			strcpy(line[counter], lines); // read file lines and assign value to line array
			counter++; // add 1 to counter, so the next line can be read
		}
		fclose(fileptr); // close the file stream
		if(atoi(line[0]) >= 1 && atoi(line[0]) <= 80 && atoi(line[1]) >= 0 && atoi(line[1]) <= 18 && (atoi(line[2]) == 0 || atoi(line[2]) == 1) && (atoi(line[3]) == 0 || atoi(line[3]) == 1) && (atoi(line[4]) == 0 || atoi(line[4]) == 1) && (atoi(line[5]) == 0 || atoi(line[5]) == 1) && (atoi(line[6]) == 0 || atoi(line[6]) == 1) && (atoi(line[7]) == 0 || atoi(line[7]) == 1) && atoi(line[8]) >= EDITINGSENSITIVITY && atoi(line[8]) <= EDITINGCROSSHAIR && counter == 10) // check mouseinjector.ini values to see if they are valid and safe to load
		{
			CFG.sensitivity = atoi(line[0]);
			CFG.crosshair = atoi(line[1]);
			CFG.invertpitch = atoi(line[2]);
			CFG.crouchtoggle = atoi(line[3]);
			CFG.geaimmode = atoi(line[4]);
			CFG.pdradialnav = atoi(line[5]);
			CFG.debug = atoi(line[6]);
			CFG.showsettings = atoi(line[7]);
			CFG.selectedoption = atoi(line[8]);
			CFG.crouchkey = atoi(line[9]);
#ifdef DEBUGMODE
			if(CFG.debug && !CFG.showsettings) // if debug mode is on and settings are locked (aka hidden), debug mode cannot be turned off. To avoid this, disable debug mode if showsettings is off
#endif
			CFG.debug = 0; // always disable debug mode in the release build
		}
		else
		{
			MessageBox(HWND_DESKTOP, "Loading mouseinjector.ini failed!\n\nUnknown values detected, loading default settings.", "Error", MB_ICONERROR | MB_OK); // tell the user loading mouseinjector.ini failed
			SaveSettings(); // overwrite mouseinjector.ini with valid settings
		}
	}
	else // if loading file failed
	{
		MessageBox(HWND_DESKTOP, "Loading mouseinjector.ini failed!\n\nAttempting to create mouseinjector.ini file.", "Error", MB_ICONERROR | MB_OK); // tell the user loading mouseinjector.ini failed
		SaveSettings(); // create mouseinjector.ini
	}
}
//==========================================================================
// Purpose: saves current settings to mouseinjector.ini
//==========================================================================
void SaveSettings(void)
{
	FILE *fileptr; // create a file pointer and open mouseinjector.ini from same dir as our program
	if((fileptr = fopen("mouseinjector.ini", "w")) != NULL) // if the INI exists
	{
		fprintf(fileptr, "%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d\n%d", CFG.sensitivity, CFG.crosshair, CFG.invertpitch, CFG.crouchtoggle, CFG.geaimmode, CFG.pdradialnav, CFG.debug, CFG.showsettings, CFG.selectedoption, CFG.crouchkey); // write current settings to mouseinjector.ini
		fclose(fileptr); // close the file stream
	}
	else // if saving file failed
		MessageBox(HWND_DESKTOP, "Saving mouseinjector.ini failed!", "Error", MB_ICONERROR | MB_OK); // tell the user saving mouseinjector.ini failed
}
//==========================================================================
// Purpose: call MouseMovement function and inject mouse x and y into current game
// Q: Could you explain this line? bypassaimmode || !aimingflag ? xrot / 10.0f * (CFG.sensitivity / 40.0f) : aimx
// A: The above line is used to calculate X axis camera rotation (camx). For this example lets assume you are playing the original GoldenEye rom with EMU.overclock and CFG.geaimmode on. If the player is not in aim mode, regular mouselook will be calculated from the first part of the line. However if the player is aiming (aimingflag = 1), then mouselook will be disabled. This is designed so when the player is aiming with the crosshair, the view will be locked (like if you were aiming with the N64 controller). However if the crosshair moves near the edge of the screen, then aimx is set to a value calculated by the GEAimMode function. The X axis camera rotation then uses aimx as input, which will make the screen scroll to whatever side the crosshair is touching. But, if bypassaimmode is true then everything related with aiming mode is bypassed and the first part of the argument will always be used (aka always mouselook)
// Q: What does this line mean? bypassaimmode = CFG.geaimmode && EMU.overclock ? (ReadMemoryInt(GE_customweaponflag, 0) != 0x756E6172 ? 1 : 0) : 1;
// A: bypassaimmode will be set to true if CFG.geaimmode is turned off, or EMU.overclock flag is not present, or GE rom has custom weapons. bypassaimmode is then used as a flag to bypass aiming mode (aka always mouselook)
// Q: Why is aiming mode disabled for non-overclocked emulators?
// A: If the emulator is not overclocked the crosshair cannot be locked perfectly. The result will look 'twitchy' and you will see some visible injection artifacts with the crosshair. It's better to just disable aiming mode altogether for non-overclocked emulators
// Q: Why is aiming mode disabled for ROM hacks with custom weapons?
// A: Custom weapons would most likely mean the gun rotation table in GEAimMode() will no longer be accurate. This would result in weapon models not lining up to the crosshair. So to avoid this we check to see if the first weapon's title address has been moved. If this is true then we ignore the aiming flag. This also applies for the lines: if(bypassaimmode || GEAimMode(aimingflag, fov)) and if(CFG.crosshair && (bypassaimmode || !aimingflag))
// Q: Could you explain !aimingflag ? 10.0f : 40.0f
// A: While the player is aiming weapon sway will be reduced by 75%. While this is not in the original design of GE/PD I feel it gives a legitimate advantage for aiming instead of only making the crosshair visible
//==========================================================================
void Inject(void)
{
	MouseMovement(); // get latest mouse input (xrot/yrot)
	if(currentgame == PLAYINGGOLDENEYE)
	{
		const int camera = ReadMemoryInt(GE_camera, 0), dead = ReadMemoryInt(playerbase, GE_deathflag), watch = ReadMemoryInt(playerbase, GE_watch), exit = ReadMemoryInt(GE_exit, 0), pause = ReadMemoryInt(GE_pause, 0), aimingflag = ReadMemoryInt(playerbase, GE_aimingflag), menupage = ReadMemoryInt(GE_menupage, 0), tankflag = ReadMemoryInt(GE_tankflag, 0), mproundend = ReadMemoryInt(GE_matchended, 0), mppausemenu = ReadMemoryInt(playerbase, GE_multipausemenu), bypassaimmode = CFG.geaimmode && EMU.overclock ? (ReadMemoryInt(GE_customweaponflag, 0) != 0x756E6172 ? 1 : 0) : 1;
		const float fov = ReadMemoryFloat(playerbase, GE_fov), gunsensitivity = (CFG.sensitivity / 40.0f) * (CFG.crosshair / 2.5f);
		float camx = ReadMemoryFloat(playerbase, GE_camx), camy = ReadMemoryFloat(playerbase, GE_camy);
		if(camx >= 0 && camx <= 360 && camy >= -90 && camy <= 90 && fov >= 7 && fov <= 60 && dead == 0 && watch == 0 && pause == 0 && (camera == 4 || camera == 0) && exit == 1 && menupage == 11 && !mproundend && !mppausemenu) // if safe to inject
		{
			if(!tankflag) // only allow crouching if player is not in tank
				Crouch();
			else
				ResetCrouchToggle(); // reset crouch toggle if in tank
			if(bypassaimmode || GEAimMode(aimingflag, fov)) // allow mouselook if the player isn't aiming or if the crosshair wants to scroll, but if bypassaimmode is true then always mouselook (see FAQ)
			{
				if(!tankflag) // player is on foot
				{
					camx += (bypassaimmode || !aimingflag ? xrot / 10.0f * (CFG.sensitivity / 40.0f) : aimx) * (fov / 60);
					if(camx < 0)
						camx += 360;
					else if(camx >= 360)
						camx -= 360;
					WriteMemoryFloat(playerbase, camx, GE_camx);
				}
				else // player is in tank
				{
					float tankx = ReadMemoryFloat(GE_tankxrot, 0) + (bypassaimmode || !aimingflag ? xrot / 10.0f * (CFG.sensitivity / 40.0f) : aimx) / (360 / TANKXROTATIONLIMIT * 2.5) * (fov / 60);
					if(tankx < 0)
						tankx += TANKXROTATIONLIMIT;
					else if(tankx >= TANKXROTATIONLIMIT)
						tankx -= TANKXROTATIONLIMIT;
					WriteMemoryFloat(GE_tankxrot, tankx, 0);
				}
				camy += (bypassaimmode || !aimingflag ? (!CFG.invertpitch ? -yrot : yrot) / 10.0f * (CFG.sensitivity / 40.0f) : -aimy) * (fov / 60);
				if(camy < -20 && tankflag) // tank limits player from looking down -20
					camy = -20;
				if(camy < -90)
					camy = -90;
				else if(camy > 90)
					camy = 90;
				WriteMemoryFloat(playerbase, camy, GE_camy);
				if(CFG.crosshair && (bypassaimmode || !aimingflag)) // if crosshair movement is enabled (do not bother calculating weapon movement while the player is in aim mode, unless bypassaimmode is true)
				{
					if(!tankflag)
					{
						float gunx = ReadMemoryFloat(playerbase, GE_gunx), crosshairx = ReadMemoryFloat(playerbase, GE_crosshairx); // after camera x and y have been calculated and injected, calculate the gun/crosshair movement
						gunx += xrot / (!aimingflag ? 10.0f : 40.0f) * gunsensitivity * (fov / 60) * 0.019f;
						crosshairx += xrot / (!aimingflag ? 10.0f : 40.0f) * gunsensitivity * (fov / 4 / 15) * 0.01912f;
						if(gunx < -GEGUNAIMLIMIT)
							gunx = -GEGUNAIMLIMIT;
						else if(gunx > GEGUNAIMLIMIT)
							gunx = GEGUNAIMLIMIT;
						if(crosshairx < -GECROSSHAIRLIMIT)
							crosshairx = -GECROSSHAIRLIMIT;
						else if(crosshairx > GECROSSHAIRLIMIT)
							crosshairx = GECROSSHAIRLIMIT;
						WriteMemoryFloat(playerbase, gunx, GE_gunx);
						WriteMemoryFloat(playerbase, crosshairx, GE_crosshairx);
					}
					if((!tankflag && camy > -90 || tankflag && camy > -20) && camy < 90) // only allow player's gun to pitch within a valid range
					{
						float guny = ReadMemoryFloat(playerbase, GE_guny), crosshairy = ReadMemoryFloat(playerbase, GE_crosshairy);
						guny += (!CFG.invertpitch ? yrot : -yrot) / (!aimingflag ? 40.0f : 20.0f) * gunsensitivity * (fov / 60) * 0.025f;
						crosshairy += (!CFG.invertpitch ? yrot : -yrot) / (!aimingflag ? 40.0f : 20.0f) * gunsensitivity * (fov / 4 / 15) * 0.0225f;
						if(guny < -GEGUNAIMLIMIT)
							guny = -GEGUNAIMLIMIT;
						else if(guny > GEGUNAIMLIMIT)
							guny = GEGUNAIMLIMIT;
						if(crosshairy < -GECROSSHAIRLIMIT)
							crosshairy = -GECROSSHAIRLIMIT;
						else if(crosshairy > GECROSSHAIRLIMIT)
							crosshairy = GECROSSHAIRLIMIT;
						WriteMemoryFloat(playerbase, guny, GE_guny);
						WriteMemoryFloat(playerbase, crosshairy, GE_crosshairy);
					}
				}
			}
		}
		else if(menupage != 11 && menupage != 23) // if user is in menu
		{
			float menucrosshairx = ReadMemoryFloat(GE_menux, 0), menucrosshairy = ReadMemoryFloat(GE_menuy, 0);
			menucrosshairx += xrot / 10.0f * (CFG.sensitivity / 40.0f) * 6;
			menucrosshairy += yrot / 10.0f * (CFG.sensitivity / 40.0f) * (400.0f / 290.0f * 6); // y is a little weaker then x in the menu so add more power to make it feel even with x axis
			if(menucrosshairx < 20)
				menucrosshairx = 20;
			else if(menucrosshairx > 420)
				menucrosshairx = 420;
			if(menucrosshairy < 20)
				menucrosshairy = 20;
			else if(menucrosshairy > 310)
				menucrosshairy = 310;
			WriteMemoryFloat(GE_menux, menucrosshairx, 0);
			WriteMemoryFloat(GE_menuy, menucrosshairy, 0);
		}
		else if(dead) // if player is dead reset crouch toggle
			ResetCrouchToggle();
	}
	else // playing perfect dark
	{
		const int camera = ReadMemoryInt(PD_camera, 0), dead = ReadMemoryInt(playerbase, PD_deathflag), menu = ReadMemoryInt(PD_menu, 0), pause = ReadMemoryInt(PD_pause, 0), mppause = ReadMemoryInt(PD_mppause, 0), aimingflag = ReadMemoryInt(playerbase, PD_aimingflag), grabflag = ReadMemoryInt(playerbase, PD_grabflag);
		const float fov = ReadMemoryFloat(playerbase, PD_fov), gunsensitivity = (CFG.sensitivity / 40.0f) * (CFG.crosshair / 2.5f);
		float camx = ReadMemoryFloat(playerbase, PD_camx), camy = ReadMemoryFloat(playerbase, PD_camy), bikex = ReadMemoryFloat(bikebase[0], 0), bikeroll = ReadMemoryFloat(bikebase[0], PD_bikeroll);
		if(camx >= 0 && camx <= 360 && camy >= -90 && camy <= 90 && fov >= 2 && fov <= 60 && dead == 0 && (menu == 0 || menu == 1) && pause == 0 && mppause < 16777476 && camera == 1 && (grabflag == 0 || grabflag == 4 || grabflag == 3 && bikebase[0] && bikex <= BIKEXROTATIONLIMIT && bikex >= -BIKEXROTATIONLIMIT && bikeroll <= BIKEROLLLIMIT && bikeroll >= -BIKEROLLLIMIT)) // if safe to inject
		{
			if(!menu) // do not compute mouselook if player is in menu
			{
				if(CFG.pdradialnav)
					PDRadialNav(); // check if player is in radial menu and translate mouse input to C buttons
				return;
			}
			if(grabflag != 3) // if player is on foot
			{
				camx += xrot / 10.0f * (CFG.sensitivity / 40.0f) * (fov / 60);
				if(camx < 0)
					camx += 360;
				else if(camx >= 360)
					camx -= 360;
				WriteMemoryFloat(playerbase, camx, PD_camx);
				Crouch();
			}
			else // if player is riding hoverbike (and hoverbike address is valid)
			{
				ResetCrouchToggle(); // reset crouch toggle if on hoverbike
				bikex -= xrot / 10.0f * (CFG.sensitivity / 40.0f) / (360 / BIKEXROTATIONLIMIT) * (fov / 60);
				bikeroll += xrot / 10.0f * (CFG.sensitivity / 40.0f) * (fov / 60) / 100;
				if(bikex < 0)
					bikex += BIKEXROTATIONLIMIT;
				else if(bikex >= BIKEXROTATIONLIMIT)
					bikex -= BIKEXROTATIONLIMIT;
				if(bikeroll < -BIKEROLLLIMIT)
					bikeroll = -BIKEROLLLIMIT;
				else if(bikeroll > BIKEROLLLIMIT)
					bikeroll = BIKEROLLLIMIT;
				WriteMemoryFloat(bikebase[0], bikex, 0);
				WriteMemoryFloat(bikebase[0], bikeroll, PD_bikeroll);
			}
			camy += (!CFG.invertpitch ? -yrot : yrot) / 10.0f * (CFG.sensitivity / 40.0f) * (fov / 60);
			if(camy < -90)
				camy = -90;
			else if(camy > 90)
				camy = 90;
			WriteMemoryFloat(playerbase, camy, PD_camy);
			if(CFG.crosshair) // if crosshair movement is enabled
			{
				float gunx = ReadMemoryFloat(playerbase, PD_gunrx), crosshairx = ReadMemoryFloat(playerbase, PD_crosshairx); // after camera x and y have been calculated and injected, calculate the gun/crosshair movement
				gunx += xrot / (!aimingflag ? 10.0f : 40.0f) * gunsensitivity * (fov / 60) * 0.05f;
				crosshairx += xrot / (!aimingflag ? 10.0f : 40.0f) * gunsensitivity * (fov / 4 / 15) * 0.05f;
				if(gunx < -PDGUNAIMLIMIT)
					gunx = -PDGUNAIMLIMIT;
				else if(gunx > PDGUNAIMLIMIT)
					gunx = PDGUNAIMLIMIT;
				if(crosshairx < -PDCROSSHAIRLIMIT)
					crosshairx = -PDCROSSHAIRLIMIT;
				else if(crosshairx > PDCROSSHAIRLIMIT)
					crosshairx = PDCROSSHAIRLIMIT;
				WriteMemoryFloat(playerbase, gunx, PD_gunrx);
				WriteMemoryFloat(playerbase, gunx, PD_gunlx);
				WriteMemoryFloat(playerbase, crosshairx, PD_crosshairx);
				if(camy > -90 && camy < 90) // only allow player's gun to pitch within a valid range
				{
					float guny = ReadMemoryFloat(playerbase, PD_gunry), crosshairy = ReadMemoryFloat(playerbase, PD_crosshairy);
					guny += (!CFG.invertpitch ? yrot : -yrot) / (!aimingflag ? 10.0f : 40.0f) * gunsensitivity * (fov / 60) * 0.075f;
					crosshairy += (!CFG.invertpitch ? yrot : -yrot) / (!aimingflag ? 10.0f : 40.0f) * gunsensitivity * (fov / 4 / 15) * 0.1f;
					if(guny < -PDGUNAIMLIMIT)
						guny = -PDGUNAIMLIMIT;
					else if(guny > PDGUNAIMLIMIT)
						guny = PDGUNAIMLIMIT;
					if(crosshairy < -PDCROSSHAIRLIMIT)
						crosshairy = -PDCROSSHAIRLIMIT;
					else if(crosshairy > PDCROSSHAIRLIMIT)
						crosshairy = PDCROSSHAIRLIMIT;
					WriteMemoryFloat(playerbase, guny, PD_gunry);
					WriteMemoryFloat(playerbase, guny, PD_gunly);
					WriteMemoryFloat(playerbase, crosshairy, PD_crosshairy);
				}
			}
		}
		else if(dead || camera != 1) // if player is dead or not in first person camera
			ResetCrouchToggle(); // reset crouch toggle
	}
}
//==========================================================================
// Purpose: crouching function for GoldenEye/Perfect Dark (2 = stand, 0 = duck)
// Changes Globals: safetoduck, crouchstance, safetostand
// Q: Can you explain the large if else statement?
// A: When the player is holding down crouch while aiming, GE will force the player to stand as part of its auto stand design. The code below combats this by injecting the correct button combinations required to crouch and stand without any interference from auto stand. Read below for a more complex explanation.
//
// Pressing R will make the player stand and pressing R + c-down will make the player crouch. If the player is pressing CTRL while in aiming mode then the below code will inject c-down into the controller address, which will make the player crouch (this is to combat the auto stand design while pressing R). The only issue with this technique (besides from being hacky) is when the player has the sniper rifle equipped, c-up and c-down are instead used to control the zoom for the sniper rifle. This means the c-down injection method will make the sniper rifle zoom out instead of making the player crouch. The sniper rifle is the only weapon which does not require c-down to make the player crouch (playerbase = 0 works fine). A cheap way around this is to disable the c-down injection when the current weapon id matches the sniper rifle id (17). This fixes the problem but introduces a new one.
//
// ROM hacks with custom weapons will probably have another weapon for slot 17 (most likely not a sniper rifle). An example is the ROM hack GoldFinger 64 which has their version of the sniper rifle under a different weapon id. This means the method of comparing the current weapon id with the default sniper id will not work. To combat this the if else statement will only compare weapon ids if the first weapons's title is called "Unarmed". This is an effective method as the chances of a ROM hack with custom weapons will most likely have new weapon names which means the address for the title of the first weapon will have been moved. If true, the if else statement will use an alternative fail-safe for detecting if the player has the sniper equipped or not.
//
// If the player has the sniper equipped and the address for the title of the first weapon has not been moved, then it is assumed the emu is playing the original version of GoldenEye 007 which will cause the if else statement to fail and the below playerbase injection will make the player crouch instead of using the c-down injection (this works fine for snipers). If the emu is playing a ROM hack then the if else statement will use an alternative detection method. This alternative is unpolished but at least works. It first checks to see if the player is standing (playerbase == 2) and if so applies the c-down injection hack. If the player is ducking (playerbase =! 2) but the view is still above -99, then it will go ahead and apply the c-down hack. This will make the player crouch normally but if the player has the sniper rifle equipped then it will make the sniper unzoom until the player has fully ducked. This is a better alternative to the player standing.
//==========================================================================
void Crouch(void)
{
	int crouchheld = GetAsyncKeyState(CFG.crouchkey);
	if(CFG.crouchtoggle) // check and change player stance
	{
		if(safetoduck && crouchheld) // standing to ducking
			safetoduck = 0, crouchstance = 1;
		if(!safetoduck && !crouchheld) // crouch is no longer being held, ready to stand
			safetostand = 1;
		if(safetostand && crouchheld) // standing up
			safetoduck = 1, crouchstance = 0;
		if(safetostand && safetoduck && !crouchheld) // crouch key not active, ready to change toggle
			safetostand = 0;
		crouchheld = crouchstance;
	}
	if(currentgame == PLAYINGGOLDENEYE && crouchheld && ReadMemoryInt(playerbase, GE_aimingflag) && (ReadMemoryInt(playerbase, GE_currentweapon) != 17 && ReadMemoryInt(GE_customweaponflag, 0) == 0x756E6172 || (playerbase == 2 || ReadMemoryFloat(playerbase, GE_crouchheight) >= -99.5f) && ReadMemoryInt(GE_customweaponflag, 0) != 0x756E6172)) // player is holding down crouch and aiming so bind c-down to the controller address (see FAQ for more information)
	{
		const int controller = ReadMemoryInt(GE_controller, 0), controllercombos[9] = {0x00100000, 0x20100000, 0x40100000, 0x80100000, 0x60100000, 0xC0100000, 0xA0100000, 0xE0100000}; // aiming, firing, reloading, changing weapons, reloading and firing, reloading and changing weapons, firing and changing weapons, firing reloading and changing weapons
		for(int i = 0; i < 9; i++)
			for(int j = 0; j < 3; j++)
				if(controller == controllercombos[i] + j * 0x10000)
				{
					WriteMemoryInt(GE_controller, controllercombos[i] + j * 0x10000 + 0x40000, 0);
					return;
				}
	}
	if(crouchheld) // user is holding down the crouch button
		WriteMemoryInt(playerbase, 0, 0); // set in-game crouch flag to lowest point
	else // player isn't holding down crouch
		WriteMemoryInt(playerbase, 2, 0); // force standing flag value (the side effect to this brute force method is it causes a speed glitch while crawling in tunnels in PD only)
}
//==========================================================================
// Purpose: replicate the original aiming system for GE, returns 1 if crosshair is near the screen border and requires the pov to scroll
// Changes Globals: crosshairposx, crosshairposy, aimx, aimy
//==========================================================================
int GEAimMode(const int aimingflag, const float fov)
{
	int enablemouselook = 1;
	const float crosshairx = ReadMemoryFloat(playerbase, GE_crosshairx), crosshairy = ReadMemoryFloat(playerbase, GE_crosshairy), offsetpos[2][33] = {{0, 0, 0, 0, 0.125, 0.125, 0.15, 0.5, 0.8, 0.4, 0.5, 0.5, 0.55, 0.9, 0.25, 0.625, 0.65, 0.85, 0.25, 0.15, 0.125, 0.125, 0.5, 1.3, 1, 1.05, 0, 0, 0, 0, 1.3, 1.7}, {0, 0, 0, 0, 0.1, 0.1, 0.2, 0.325, 1, 0.3, 0.425, 0.425, 0.525, 0.95, 0.1, 0.55, 0.9, 0.8, 0.25, 0.1, 0.1, 0.1, 0.275, 1.925, 1, 1.3, 0, 0, 0, 0, 0.8, 0.65}}; // table of X/Y offset for weapons
	const int currentweapon = ReadMemoryInt(playerbase, GE_currentweapon);
	if(aimingflag) // if player is aiming
	{
		enablemouselook = 0;
		crosshairposx += xrot / 10.0f * (CFG.sensitivity / 292.0f); // calculate the crosshair position
		crosshairposy += (!CFG.invertpitch ? yrot : -yrot) / 10.0f * (CFG.sensitivity / 292.0f);
		if(crosshairposx < -GECROSSHAIRLIMIT) // apply limits then inject
			crosshairposx = -GECROSSHAIRLIMIT;
		else if(crosshairposx > GECROSSHAIRLIMIT)
			crosshairposx = GECROSSHAIRLIMIT;
		if(crosshairposy < -GECROSSHAIRLIMIT)
			crosshairposy = -GECROSSHAIRLIMIT;
		else if(crosshairposy > GECROSSHAIRLIMIT)
			crosshairposy = GECROSSHAIRLIMIT;
		WriteMemoryFloat(playerbase, crosshairposx, GE_crosshairx);
		WriteMemoryFloat(playerbase, crosshairposy, GE_crosshairy);
		WriteMemoryFloat(playerbase, crosshairposx * (1.11f + (currentweapon >= 0 && currentweapon <= 32 ? offsetpos[0][currentweapon] : 0.15f)) + (fov / 60) - 1, GE_gunx); // calculate and inject the gun angles (uses pre-made pos table or if unknown weapon use fail-safe value)
		WriteMemoryFloat(playerbase, crosshairposy * (1.11f + (currentweapon >= 0 && currentweapon <= 32 ? offsetpos[1][currentweapon] : 0)) + (fov / 60) - 1, GE_guny);
		if(crosshairx > 0 && crosshairx / GECROSSHAIRLIMIT > 0.9f) // if crosshair is within the last 90% of the border then calculate a linear scrolling speed and enable mouselook
			aimx = (crosshairx / GECROSSHAIRLIMIT - 0.9f) * 1500 * TIMESTEP, enablemouselook = 1;
		else if(crosshairx < 0 && crosshairx / GECROSSHAIRLIMIT < -0.9f)
			aimx = (crosshairx / GECROSSHAIRLIMIT + 0.9f) * 1500 * TIMESTEP, enablemouselook = 1;
		else
			aimx = 0;
		if(crosshairy > 0 && crosshairy / GECROSSHAIRLIMIT > 0.9f)
			aimy = (crosshairy / GECROSSHAIRLIMIT - 0.9f) * 1500 * TIMESTEP, enablemouselook = 1;
		else if(crosshairy < 0 && crosshairy / GECROSSHAIRLIMIT < -0.9f)
			aimy = (crosshairy / GECROSSHAIRLIMIT + 0.9f) * 1500 * TIMESTEP, enablemouselook = 1;
		else
			aimy = 0;
	}
	else // player is not aiming so reset crosshairposxy values
		crosshairposx = crosshairx, crosshairposy = crosshairy;
	return enablemouselook;
}
//==========================================================================
// Purpose: translate mouse to weapon radial menu
// Changes Globals: xradial, yradial
//==========================================================================
void PDRadialNav(void)
{
	const float max = 19, threshold = 13, diagonalthres = 0.75;
	const unsigned int controller = ReadMemoryInt(PD_controller, 0);
	if(controller >= 0x80000000 && controller <= 0x801F0000) // if a button is held
	{
		unsigned int button = 0;
		xradial += xrot / 10.0f * (CFG.sensitivity / 40.0f);
		yradial += yrot / 10.0f * (CFG.sensitivity / 40.0f);
		if(xradial > max)
			xradial = max;
		else if(xradial < -max)
			xradial = -max;
		if(yradial > max)
			yradial = max;
		else if(yradial < -max)
			yradial = -max;
		if(xradial > threshold) // c-right
			button = 0x10000;
		else if(xradial < -threshold) // c-left
			button = 0x20000;
		if(yradial > threshold) // c-down
			button = 0x40000;
		else if(yradial < -threshold) // c-up
			button = 0x80000;
		if(xradial > threshold && yradial > threshold && (xradial + yradial) / (max * 2) > diagonalthres) // c-right-down
			button = 0x50000;
		else if(xradial < -threshold && yradial > threshold && (-xradial + yradial) / (max * 2) > diagonalthres) // c-left-down
			button = 0x60000;
		else if(xradial > threshold && yradial < -threshold && (xradial + -yradial) / (max * 2) > diagonalthres) // c-right-up
			button = 0x90000;
		else if(xradial < -threshold && yradial < -threshold && (-xradial + -yradial) / (max * 2) > diagonalthres) // c-left-up
			button = 0xA0000;
		if(controller >= 0x80100000) // r button is being held, add r value to button
			button += 0x00100000;
		WriteMemoryInt(PD_controller, 0x80000000 + button, 0);
	}
	else
		xradial = 0, yradial = 0;
}
//==========================================================================
// Purpose: force PD to unlock fps
//==========================================================================
void PDSpeedHack(void)
{
	if((unsigned int)ReadMemoryInt(PD_fpscounter, 0) == 0x8005EE68 && ReadMemoryInt(PD_speed, 0) == 0 && (unsigned int)ReadMemoryInt(PD_mpspeed, 0) < 0x40000000) // if PD is running under 60fps and the player isn't using combat boost and match settings is not in slow motion
	{
		for(int i = 0; i < 96; i++)
			WriteMemoryInt(PD_timer, 0x00000000, 0); // intentionally screw with the timing system
		WriteMemoryInt(PD_timer, 0x00010000, 0); // set clock address back to default (reset fps lock to 60)
	}
}
//==========================================================================
// Purpose: searches for the current map memory locations
// Changes Globals: playerbase, currentgame, bikebase
//==========================================================================
void DetectMap(void)
{
	if(currentgame != Game()) // if game has been changed, reset playerbase and update currentgame
	{
		playerbase = 0;
		currentgame = Game();
		Interface();
	}
	if(currentgame == PLAYINGGOLDENEYE)
	{
		if(playerbase != BONDDATA && (ReadMemoryInt(GE_camera, 0) == 1 || ReadMemoryInt(GE_camera, 0) == 4 || ReadMemoryInt(GE_camera, 0) == 9))
		{
			int pointerdump[64];
			ResetCrouchToggle(); // reset crouch toggle on new map
			for(int i = 0; i < 64; i++)
			{
				pointerdump[i] = BONDDATA;
				Sleep(1);
			}
			SortArray(pointerdump, sizeof pointerdump / sizeof pointerdump[0]);
			playerbase = pointerdump[0];
#ifdef PLAYER2MODE
			for(int j = 1; j < 64; j++)
				if(pointerdump[j - 1] != pointerdump[j]) // search pointerdump array until P2's pointer is found
				{
					playerbase = pointerdump[j];
					break;
				}
#endif
		}
	}
	else if(currentgame == PLAYINGPERFECTDARK)
	{
		if(playerbase != JOANNADATA && (ReadMemoryInt(PD_camera, 0) == 1 || ReadMemoryInt(PD_camera, 0) == 3 || ReadMemoryInt(PD_camera, 0) == 4 || ReadMemoryInt(PD_camera, 0) == 6))
		{
			ResetCrouchToggle(); // reset crouch toggle on new map
			playerbase = JOANNADATA;
		}
		if(ReadMemoryInt(playerbase, PD_grabflag) == 3 && bikebase[1] != 3) // player has hopped on a bike, search for bike pointer
		{
			const unsigned int bikepointers[14] = {0x8052D5DC, 0x8054B1E8, 0x80552D8C, 0x8052A4FC, 0x8054ECDC, 0x80556DF4, 0x80501438, 0x8050EED4, 0x805142A4, 0x804CA4D4, 0x804D10D4, 0x803FF4F0, 0x803FF6A4, 0x803FF7BC};
			unsigned int bikedump[64][14];
			for(int i = 0; i < 64; i++)
			{
				for(int j = 0; j < 14; j++)
				{
					bikedump[i][j] = ReadMemoryInt(bikepointers[j] - 0x80000000, 0);
					if(j > 1 && bikedump[i][j] > 0x80000000 && bikedump[i][j] < 0x80800000 && ReadMemoryFloat(bikedump[i][j] - 0x80000000 + 0x6C, 0) <= BIKEXROTATIONLIMIT && ReadMemoryFloat(bikedump[i][j] - 0x80000000 + 0x6C, 0) >= -BIKEXROTATIONLIMIT && ReadMemoryFloat(bikedump[i][j] - 0x80000000 + 0x6C, PD_bikeroll) <= BIKEROLLLIMIT && ReadMemoryFloat(bikedump[i][j] - 0x80000000 + 0x6C, PD_bikeroll) >= -BIKEROLLLIMIT && (bikedump[i][j] == bikedump[i][j - 1] || bikedump[i][j] == bikedump[i][j - 2] || bikedump[i][j - 1] == bikedump[i][j - 2]))
					{
						bikebase[0] = bikedump[i][j] - 0x80000000 + 0x6C;
						break;
					}
				}
				if(bikebase[0])
					break;
				else
					Sleep(1);
			}
		}
		else if(bikebase[1] != 3)
			bikebase[0] = 0;
		bikebase[1] = ReadMemoryInt(playerbase, PD_grabflag); // remember player's last grab state (used to find the exact moment when the player hops on a bike)
	}
}
//==========================================================================
// Purpose: returns a value, which is then used to check what game is running
// Q: What is happening here?
// A: This function looks up some static addresses and if the values are within the expected ranges the program can assume that the game is currently running
//==========================================================================
int Game(void)
{
	const int ge_camera = ReadMemoryInt(GE_camera, 0), ge_page = ReadMemoryInt(GE_menupage, 0), ge_pause = ReadMemoryInt(GE_pause, 0), ge_exit = ReadMemoryInt(GE_exit, 0), pd_menu = ReadMemoryInt(PD_menu, 0), pd_camera = ReadMemoryInt(PD_camera, 0), pd_pause = ReadMemoryInt(PD_pause, 0), pd_romcheck = ReadMemoryInt(PD_menuitem, 0);
	const float ge_crosshairx = ReadMemoryFloat(GE_menux, 0), ge_crosshairy = ReadMemoryFloat(GE_menuy, 0);
	if(ge_camera >= 0 && ge_camera <= 10 && ge_page >= -1 && ge_page <= 25 && ge_pause >= 0 && ge_pause <= 1 && ge_exit >= 0 && ge_exit <= 1 && ge_crosshairx >= 20 && ge_crosshairx <= 420 && ge_crosshairy >= 20 && ge_crosshairy <= 310) // if GoldenEye 007 is current game
		return PLAYINGGOLDENEYE;
	if(pd_menu >= 0 && pd_menu <= 1 && pd_camera >= 0 && pd_camera <= 7 && pd_pause >= 0 && pd_pause <= 1 && pd_romcheck == 0x04010000) // if Perfect Dark is current game
		return PLAYINGPERFECTDARK;
	return PLAYINGUNKNOWN; // if GE/PD not detected, return unknown rom
}
//==========================================================================
// Purpose: returns 1 if emulator is detected, and set emulator memory locations
// Changes Globals: EMU.handle, EMU.offset, EMU.overclock, tickrate
//==========================================================================
int EmulatorDetected(void)
{
	EMU.handle = NULL;
	HANDLE processes; // will store a snapshot of all processes
	PROCESSENTRY32 pe32; // stores basic info of a process, using this one to read the ProcessID from
	processes = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0); // make process snapshot
	pe32.dwSize = sizeof(PROCESSENTRY32); // correct size
	Process32First(processes, &pe32); // read info about the first process into pe32
	do // loop to find emulator
	{
		if(strcasecmp(pe32.szExeFile, "1964.exe") == 0 || strcasecmp(pe32.szExeFile, "1964x6.exe") == 0 || strcasecmp(pe32.szExeFile, "1964x9.exe") == 0 || strcasecmp(pe32.szExeFile, "1964_ultrafast.exe") == 0) // if 1964 0.8.5/1964 1.1 Ultrafast was found
		{
			EMU.handle = OpenProcess(PROCESS_VM_OPERATION | PROCESS_VM_READ | PROCESS_VM_WRITE | PROCESS_QUERY_INFORMATION, FALSE, pe32.th32ProcessID);
			EMU.offset = 0x20000000; // emulator offset is used for injecting into the ROM memory area in the emu
			EMU.overclock = 1; // this is used as a flag to show the overclocked emu only options
			tickrate = 2; // a high injection rate is needed to properly use the GE aiming system and PD 60fps hack
			break;
		}
		if(strcasecmp(pe32.szExeFile, "1964Slow.exe") == 0) // if 1964 0.8.5 was found
		{
			EMU.handle = OpenProcess(PROCESS_VM_OPERATION | PROCESS_VM_READ | PROCESS_VM_WRITE | PROCESS_QUERY_INFORMATION, FALSE, pe32.th32ProcessID);
			EMU.offset = 0x20000000;
			EMU.overclock = 0;
			tickrate = 4;
			break;
		}
		if(strcasecmp(pe32.szExeFile, "mupen64pp.exe") == 0) // if mupen64++ beta 0.1.3.12 was found
		{
			EMU.handle = OpenProcess(PROCESS_VM_OPERATION | PROCESS_VM_READ | PROCESS_VM_WRITE | PROCESS_QUERY_INFORMATION, FALSE, pe32.th32ProcessID);
			EMU.offset = 0x008DFC60;
			EMU.overclock = 0;
			tickrate = 4;
			break;
		}
		if(strcasecmp(pe32.szExeFile, "mupen64plus-ui-console.exe") == 0) // if mupen64+ 1.99.5 was found
		{
			EMU.handle = OpenProcess(PROCESS_VM_OPERATION | PROCESS_VM_READ | PROCESS_VM_WRITE | PROCESS_QUERY_INFORMATION, FALSE, pe32.th32ProcessID);
			EMU.offset = 0x101FC6D0;
			EMU.overclock = 0;
			tickrate = 4;
			break;
		}
		if(strcasecmp(pe32.szExeFile, "Project64.exe") == 0) // if Project64 1.6 was found
		{
			int versioncheck;
			EMU.handle = OpenProcess(PROCESS_VM_OPERATION | PROCESS_VM_READ | PROCESS_VM_WRITE | PROCESS_QUERY_INFORMATION, FALSE, pe32.th32ProcessID);
			ReadProcessMemory(EMU.handle, (LPVOID)0x0046AB90, &versioncheck, sizeof(versioncheck), NULL);
			if(versioncheck == 1785688656) // if version is PJ64 1.6
				ReadProcessMemory(EMU.handle, (LPVOID)0x004D6A3C, &EMU.offset, sizeof(EMU.offset), NULL); // look up rom memory offset in PJ64 1.6
			else // unsupported PJ64 version, emulator not found
				EMU.handle = NULL;
			EMU.overclock = 0;
			tickrate = 4;
			break;
		}
	}
	while(Process32Next(processes, &pe32)); // loop continued until Process32Next deliver NULL or its interrupted with the "break" above
	CloseHandle(processes);
	return EMU.handle ? 1 : 0;
}
//==========================================================================
// Purpose: displays important debugging information to programmer
//==========================================================================
void DebugInterface(void)
{
#ifdef DEBUGMODE
	int safetoinject = 0;
	printf("\n Debugging Information (Press 0 to disable)\n%s\n\n   ", LINE);
	if(currentgame)
		printf("Game: %s\n\n\n Memory Information (Tickrate: %dHz)\n%s\n\n   ", currentgame == PLAYINGGOLDENEYE ? (ReadMemoryInt(GE_customweaponflag, 0) == 0x756E6172 ? "GoldenEye 007" : "GoldenEye 007 (Custom Weapons)") : "Perfect Dark", 1000 / tickrate, LINE);
	if(currentgame == PLAYINGGOLDENEYE)
	{
		const int menupage = ReadMemoryInt(GE_menupage, 0);
		if(menupage != 11 && menupage != 23)
			printf("Menu Page ID: %d\t\t\t Address: 0x%p\n", menupage, GE_menupage + EMU.offset);
		else if(playerbase)
		{
			const int camera = ReadMemoryInt(GE_camera, 0), dead = ReadMemoryInt(playerbase, GE_deathflag), watch = ReadMemoryInt(playerbase, GE_watch), exit = ReadMemoryInt(GE_exit, 0), pause = ReadMemoryInt(GE_pause, 0), aimingflag = ReadMemoryInt(playerbase, GE_aimingflag), tankflag = ReadMemoryInt(GE_tankflag, 0), mproundend = ReadMemoryInt(GE_matchended, 0), mppausemenu = ReadMemoryInt(playerbase, GE_multipausemenu);
			const float camx = ReadMemoryFloat(playerbase, GE_camx), camy = ReadMemoryFloat(playerbase, GE_camy), crosshairx = ReadMemoryFloat(playerbase, GE_crosshairx), crosshairy = ReadMemoryFloat(playerbase, GE_crosshairy), fov = ReadMemoryFloat(playerbase, GE_fov), tankx = ReadMemoryFloat(GE_tankxrot, 0);
			if(camx >= 0 && camx <= 360 && camy >= -90 && camy <= 90 && fov >= 7 && fov <= 60 && dead == 0 && watch == 0 && pause == 0 && (camera == 4 || camera == 0) && exit == 1 && menupage == 11 && !mproundend && !mppausemenu)
				safetoinject = 1;
			printf("Safe to inject: %d\n   Menu Page ID: %d\t\t\t Address: 0x%p\n   Camera: %d\t\t\t\t Address: 0x%p\n   Dead: %d\t\t\t\t Address: 0x%p\n   Camera X: %1.4f\t\t\t Address: 0x%p\n   Camera Y: %1.4f\t\t\t Address: 0x%p\n   Crosshair X: %1.4f\t\t\t Address: 0x%p\n   Crosshair Y: %1.4f\t\t\t Address: 0x%p\n   Fov: %1.4f\t\t\t\t Address: 0x%p\n   Watch: %d\t\t\t\t Address: 0x%p\n   Exit: %d\t\t\t\t Address: 0x%p\n   Pause: %d\t\t\t\t Address: 0x%p\n   Aiming flag: %d\t\t\t Address: 0x%p\n   Tank flag: %d\t\t\t\t Address: 0x%p\n", safetoinject, menupage, GE_menupage + EMU.offset, camera, GE_camera + EMU.offset, dead, playerbase + GE_deathflag + EMU.offset, camx, playerbase + GE_camx + EMU.offset, camy, playerbase + GE_camy + EMU.offset, crosshairx, playerbase + GE_crosshairx + EMU.offset, crosshairy, playerbase + GE_crosshairy + EMU.offset, fov, playerbase + GE_fov + EMU.offset, watch, playerbase + GE_watch + EMU.offset, exit, GE_exit + EMU.offset, pause, GE_pause + EMU.offset, aimingflag, playerbase + GE_aimingflag + EMU.offset, tankflag, GE_tankflag + EMU.offset);
			if(tankflag)
				printf("   Tank X: %1.4f\t\t\t Address: 0x%p", tankx, GE_tankxrot + EMU.offset);
		}
	}
	else if(currentgame == PLAYINGPERFECTDARK)
	{
		const int camera = ReadMemoryInt(PD_camera, 0), dead = ReadMemoryInt(playerbase, PD_deathflag), menu = ReadMemoryInt(PD_menu, 0), pause = ReadMemoryInt(PD_pause, 0), mppause = ReadMemoryInt(PD_mppause, 0), aimingflag = ReadMemoryInt(playerbase, PD_aimingflag), grabflag = ReadMemoryInt(playerbase, PD_grabflag);
		const float camx = ReadMemoryFloat(playerbase, PD_camx), camy = ReadMemoryFloat(playerbase, PD_camy), fov = ReadMemoryFloat(playerbase, PD_fov), bikex = ReadMemoryFloat(bikebase[0], 0), bikeroll = ReadMemoryFloat(bikebase[0], PD_bikeroll);
		if(camx >= 0 && camx <= 360 && camy >= -90 && camy <= 90 && fov >= 2 && fov <= 60 && dead == 0 && menu == 1 && pause == 0 && mppause < 16777476 && camera == 1 && (grabflag == 0 || grabflag == 4 || grabflag == 3 && bikebase[0] && bikex <= BIKEXROTATIONLIMIT && bikex >= -BIKEXROTATIONLIMIT && bikeroll <= BIKEROLLLIMIT && bikeroll >= -BIKEROLLLIMIT))
			safetoinject = 1;
		if(playerbase)
		{
			printf("Safe to inject: %d\n   FPS: %s\t\t\t %s\n   Camera: %d\t\t\t\t Address: 0x%p\n   Dead: %d\t\t\t\t Address: 0x%p\n   Camera X: %1.4f\t\t\t Address: 0x%p\n   Camera Y: %1.4f\t\t\t Address: 0x%p\n   Fov: %1.4f\t\t\t\t Address: 0x%p\n   Menu: %d\t\t\t\t Address: 0x%p\n   Pause: %d\t\t\t\t Address: 0x%p\n   Aiming Flag: %d\t\t\t Address: 0x%p\n   Grab: %d\t\t\t\t Address: 0x%p\n", safetoinject, ReadMemoryInt(PD_fpscounter, 0) != 0x8005EE68 ? "Unlocked" : "Locked at 30", EMU.overclock && ReadMemoryInt(PD_fpscounter, 0) == 0x8005EE68 && ReadMemoryInt(PD_speed, 0) == 0 && (unsigned int)ReadMemoryInt(PD_mpspeed, 0) < 0x40000000 ? "Forcing 60fps mode..." : "", camera, PD_camera + EMU.offset, dead, playerbase + PD_deathflag + EMU.offset, camx, playerbase + PD_camx + EMU.offset, camy, playerbase + PD_camy + EMU.offset, fov, playerbase + PD_fov + EMU.offset, menu, PD_menu + EMU.offset, pause, PD_pause + EMU.offset, aimingflag, playerbase + PD_aimingflag + EMU.offset, grabflag, playerbase + PD_grabflag + EMU.offset);
			if(grabflag == 3 && safetoinject)
				printf("   Bike X: %1.4f\t\t\t Address: 0x%p\n   Bike Roll: %1.4f\t\t\t Address: 0x%p", bikex, bikebase[0] + EMU.offset, bikeroll, bikebase[0] + PD_bikeroll + EMU.offset);
		}
	}
	else
		printf("Waiting for correct ROM...\n");
#endif
}
//==========================================================================
// Purpose: read interger from memory and then return memory value
// Parameter: address location plus offset
//==========================================================================
int ReadMemoryInt(const unsigned int addr, const unsigned int offset)
{
	int output;
	ReadProcessMemory(EMU.handle, (LPVOID)(addr + EMU.offset + offset), &output, sizeof(output), NULL);
	return output;
}
//==========================================================================
// Purpose: read float from memory and then return memory value
// Parameter: address location plus offset
//==========================================================================
float ReadMemoryFloat(const unsigned int addr, const unsigned int offset)
{
	float output;
	ReadProcessMemory(EMU.handle, (LPVOID)(addr + EMU.offset + offset), &output, sizeof(output), NULL);
	return output;
}
//==========================================================================
// Purpose: write int to memory location
// Parameter: address location, value and offset
//==========================================================================
void WriteMemoryInt(const unsigned int addr, const int value, const unsigned int offset)
{
	WriteProcessMemory(EMU.handle, (LPVOID)(addr + EMU.offset + offset), &value, sizeof(value), NULL);
}
//==========================================================================
// Purpose: write float to memory location
// Parameter: address location, value and offset
//==========================================================================
void WriteMemoryFloat(const unsigned int addr, const float value, const unsigned int offset)
{
	WriteProcessMemory(EMU.handle, (LPVOID)(addr + EMU.offset + offset), &value, sizeof(value), NULL);
}
//==========================================================================
// Purpose: clear screen without using system("cls")
//==========================================================================
void ClearScreen(void)
{
	DWORD n; // number of characters written
	DWORD size; // number of visible characters
	COORD coord = {0}; // top left screen position
	CONSOLE_SCREEN_BUFFER_INFO csbi;
	HANDLE h = GetStdHandle(STD_OUTPUT_HANDLE); // get a handle to the console
	GetConsoleScreenBufferInfo(h, &csbi);
	size = csbi.dwSize.X * csbi.dwSize.Y; // find the number of characters to overwrite
	FillConsoleOutputCharacter(h, TEXT(' '), size, coord, &n); // overwrite the screen buffer with whitespace
	GetConsoleScreenBufferInfo(h, &csbi);
	FillConsoleOutputAttribute(h, csbi.wAttributes, size, coord, &n);
	SetConsoleCursorPosition(h, coord); // reset the cursor to the top left position
}
//==========================================================================
// Purpose: get mouse x and y and update global vars xrot/yrot with current mouse input values
// Changes Globals: xrot, yrot, MOUSE.event
//==========================================================================
void MouseMovement(void)
{
	xrot = 0, yrot = 0; // reset input
	SetCursorPos(MOUSE.lock.x, MOUSE.lock.y); // set mouse position to lock position
	while(ManyMouse_PollEvent(&MOUSE.event))
	{
		if(MOUSE.event.type == MANYMOUSE_EVENT_RELMOTION)
		{
			if(MOUSE.event.item == 0)
				xrot += MOUSE.event.value;
			else
				yrot += MOUSE.event.value;
		}
	}
}
//==========================================================================
// Purpose: sorting function for pointer scanning
//==========================================================================
void SortArray(int *a, const int n)
{
	if(n < 2)
		return;
	int p = a[n / 2];
	int *l = a;
	int *r = a + n - 1;
	while(l <= r)
	{
		while(*l < p)
			l++;
		while(*r > p)
			r--;
		if(l <= r)
		{
			int t = *l;
			*l++ = *r;
			*r-- = t;
		}
	}
	SortArray(a, r - a + 1);
	SortArray(l, a + n - l);
}